function [f,g,ll_func_eval]=bltp_12(x,counter,varargin)

p=2;q=2;
if nargin == 0
    prob.name = mfilename;
    ux=p;lx=q;
    prob.nx = ux+lx;
    prob.nf = 2;  %upper level
    prob.ng=4;
    prob.ngu = 1;  %upper level
    prob.ngl=3;   %lower level
    prob.nxl=lx;
    prob.nxu=ux;
    prob.range = cell(1, prob.nx);
    ind=1;
    %variable for u1
    for i = 1:p
       prob.range{ind} = [0,2];
        ind=ind+1;
    end

    %variable for l1
    for i=1:q
       prob.range{ind} = [0,2];
        ind=ind+1;
    end
    
    f = prob;
else
 
        [f,g,ll_func_eval] = smd1_true_ul(x,counter);
    
end
return


function [f,g,ll_func_eval] = smd1_true_ul(x,counter)


nn=[];
p=2;q=2;g=[];
xu1=x(1:p);xl1=x(p+1:end);
xu=[xu1];
xl=[xl1];
ll_func_eval=[];
params;
archive=[];
x_tmp = [];
del_x_res = 1e-6; 
xllb=[0 0];
xlub=[2 2];
f_tol=0;
f_tol_dif=1e-6;
[f_base, g_base]=myfun_ll(xu,xl);
if counter==1
    if sum(min(g_base)<0)
        violation = 0;
    else
    for i = 1:length(del_x_res)
        del_x=del_x_res(i)*ones(1,length(xl));
        x_tmp = [x_tmp; repmat(xl,length(xl),1)+diag(del_x); repmat(xl,length(xl),1)+diag(-del_x)];
    end
    tmp_ll = repmat(xllb,size(x_tmp,1),1);
    tmp_ul = repmat(xlub,size(x_tmp,1),1);
    x_tmp = max(x_tmp,tmp_ll);
    x_tmp = min(x_tmp,tmp_ul);
    x_tmp=unique(x_tmp,'rows');
    id_rem=find(ismember(x_tmp,xl,'rows'));
    x_tmp(id_rem,:)=[];
    x_ll = x_tmp;
    nn = size(x_ll,1);
    for i = 1:nn
        [f_ll(i,:), g_ll(i,:)]=myfun_ll(xu,x_ll(i,:));
    end        
        feas_id = find(min(g_ll,[],2)>=0);
        infeas_id = setdiff(1:nn,feas_id);
        f_ll_check=[f_base;f_ll(feas_id,:)];
        pop_ll_check=[xl;x_ll(feas_id,:)];
        g_ll_check=[g_base;g_ll(feas_id,:)];
        difference = f_base-f_ll_check;
        idx1 = find(difference <= f_tol);
        idx2 = setdiff(1:length(feas_id),idx1);
        if isempty(idx2)
            violation=0;
        elseif sum(abs(difference))<=f_tol_dif
            violation=0;
        else
            violation = sum(abs(difference(idx2)));
        end
    end
end
    
g_ul=0;

if counter==1
    g=[-violation g_base g_ul];
elseif counter==2
    g=g_base;   
else
    g=g_ul;
end
if ~isempty(nn)  
    ll_func_eval=nn;
end
f_ul =2*xu(1)-xu(2)-0.5*xl(1);
f(1)=-f_ul;
f(2)=f_base;
return

function [f,g]= myfun_ll(xu,xl)

g_ll(1)=-(2*xu(1)-xl(1)+xl(2)-2.5);

g_ll(2)=-(-xu(1)+3*xu(2)-xl(2)+2);
g_ll(3)=-(-xu(1)-xu(2)+2);
f_ll=-xu(1)-xu(2)+4*xl(1)-xl(2);
f =-f_ll;
g =-g_ll;
return

